import { IResolvers, IFieldResolver } from 'graphql-tools';
export declare type ResolversComposition<Resolver extends ((...args: any[]) => any) = IFieldResolver<any, any>> = (next: Resolver) => Resolver;
export declare type ResolversComposerMapping<Resolvers extends {
    [key: string]: any;
} = IResolvers> = {
    [TypeName in string]?: TypeName extends keyof Resolvers ? {
        [FieldName in keyof Resolvers[TypeName]]?: ResolversComposition<Resolvers[TypeName][FieldName] & ((...args: any[]) => any)> | Array<ResolversComposition<Resolvers[TypeName][FieldName] & Resolvers[TypeName][FieldName] & ((...args: any[]) => any)>>;
    } : any;
};
/**
 * Wraps the resolvers object with the resolvers composition objects.
 * Implemented as a simple and basic middleware mechanism.
 *
 * @param resolvers - resolvers object
 * @param mapping - resolvers composition mapping
 * @hidden
 */
export declare function composeResolvers<Resolvers>(resolvers: Resolvers, mapping?: ResolversComposerMapping<Resolvers>): Resolvers;
